// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js  , 'ionicLazyLoad'  'me-lazyload',

angular.module('starter', ['ionic','ionic.service.core', 'ionic.service.analytics', 'ngCordova', 'starter.controllers', 'starter.services', 'ngMaterial' , 'ionicLazyLoad', 'jrCrop', 'jett.ionic.filter.bar',
'services.common.constants',
'services.common.auth',
'services.common.api',
'components.http-auth-interceptor',
'ngCordova.plugins.network',
'pascalprecht.translate'
])

.directive('focusMe', function($timeout) {
  return {
    link: function (scope, element, attrs) {
      if (attrs.focusMeDisable === "true") {
        return;
      }
      $timeout(function () {
        element[0].focus();
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.show(); //open keyboard manually
        }
      }, 350);
    }
  };
})
.directive("limitTo", [function() {
  return {
    restrict: "A",
    link: function(scope, elem, attrs) {
      var limit = parseInt(attrs.limitTo);
      angular.element(elem).on("keydown", function(e) {
        if (elem[0].value.length >= limit && e.keyCode !== 8) {
          e.preventDefault();
          return false;
        }
      });
    }
  }
}])


.run(function($window, $ionicPlatform, $ionicPopup, AuthService, Constants, $localstorage, $translate, $filter, $state, $rootScope, $http, $cordovaNetwork, $cordovaAppVersion, $cordovaGoogleAnalytics, $ionicLoading, $ionicHistory) {

  var $tran = $filter('translate');

  $ionicPlatform.ready(function () {
    //$ionicAnalytics.register();
    $rootScope.appVersion = "0.0.0";
    $ionicPlatform.registerBackButtonAction(function(event) {
      //var path = $location.path()
      console.log('android hardware back button pressed');
      console.log($state.current.name);
      if ($state.current.name == "tab.topics" || $state.current.name == 'account') {
        $ionicHistory.clearHistory();
        var confirmPopup = $ionicPopup.confirm({
          title: $tran('EXIT-CONFIRM'),
          template: $tran('CONFIRM-EXIT-APP'),
          cancelText: $tran('CANCEL-BTN'),
          okText: $tran('OK-BTN')
        });
        confirmPopup.then(function(res) {
          if(res) navigator.app.exitApp();
        });
      } else if ($state.current.name == 'tab.post-top100' || $state.current.name == 'tab.post-latest' || $state.current.name == 'tab.post-friends' || $state.current.name == 'tab.post-random') {
        //$ionicHistory.clearHistory();
        $ionicHistory.nextViewOptions({disableBack:true, historyRoot:true});
        $state.go('tab.topics');
      } else {
        $ionicHistory.goBack();
      }
      event.preventDefault();
    }, 100);

    var notificationOpenedCallback = function(jsonData) {
       //alert("Notification received:\n" + JSON.stringify(jsonData));
       console.log('didReceiveRemoteNotificationCallBack: ' + JSON.stringify(jsonData));
    };

    if (window.cordova) {
      cordova.getAppVersion.getVersionNumber(function (version) {
        $rootScope.appVersion = version;
      });
      // Update with your OneSignal AppId and googleProjectNumber before running.
      window.plugins.OneSignal.init("530f45d7-8f60-4140-8052-ad47d619a079", {googleProjectNumber: "355713309757", autoRegister: true}, notificationOpenedCallback);
      window.plugins.OneSignal.getIds(function(ids) {
        $localstorage.set('platform', ionic.Platform.platform());
        $localstorage.set('device_id', ids.userId);
      })
    };

    AuthService.ping('ionicPlatformReady').then(function(resp) {
      if(Constants.DEBUGMODE) {
        console.log('app.js AuthService.ping response: ', resp);
        //alert('auth ping success');
      }
      $rootScope.myProfile = resp;
      if (resp.is_username_set) {
        $state.go('tab.topics');
      } else {
        $state.go('invitation');
      }
    }, function(error) {
      //alert('app.js error:', error);
      $state.go('account');
    });

    if(typeof analytics !== "undefined") {
      analytics.startTrackerWithId("UA-69961799-3");
    } else {
      console.log("Google Analytics Unavailable");
    }

    // if ($window.cordova && $window.cordova.plugins.Keyboard) {
      // $window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      // $window.cordova.plugins.Keyboard.disableScroll(true);
    // }
    if ($window.cordova) $window.cordova.plugins.Keyboard.disableScroll(true);

    // if(!$cordovaNetwork.isOnline()){
      // if(Constants.DEBUGMODE){
        // console.log("No NETWORK FOUND");
        // // at this point we need to broadcast a no network found event and the app.controller will get that and display the popup
        // $rootScope.$broadcast('event:app-networkRequired');
      // }
    // }else{
      // if(Constants.DEBUGMODE){
        // console.log("NETWORK FOUND");
      // }
    // }

    // alert('ionic platform ready');

  });

  // init Authentication service
  AuthService.init();

  $rootScope.$on('event:auth-loginRequired', function() {
    //if login is required redirect to the app.start page
    AuthService.resetCookie();
    console.log('event:auth-loginRequired triggered');
    $ionicHistory.clearCache();
    $ionicHistory.clearHistory();
    event.preventDefault();
    $state.go('account');
    $ionicLoading.hide();
    //event.preventDefault();
  });


  // on state change you want to check whether or not the state.
  // I'm trying to reach is protected
  $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
    $ionicLoading.show({
      template: $tran('LOADING')
    });

    if(!toState.authenticate && !toState.name == "tab.topics" && AuthService.isLoggedIn()){
      // User is logged in redirect to profile page
      $ionicHistory.clearCache();
      // $ionicHistory.clearHistory();
      $state.transitionTo("tab.topics");
      event.preventDefault();
    }else if(toState.authenticate && !AuthService.isLoggedIn()){
      // User isn’t authenticated
      console.log(toState);
      $ionicHistory.clearCache();
      $ionicHistory.clearHistory();
      $state.transitionTo("account");
      event.preventDefault();
    }
  });

  $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams){
    if(typeof analytics !== "undefined") { analytics.trackView(toState.name) };
    $ionicLoading.hide();
  });
})


.config(function ($httpProvider) {
  $httpProvider.defaults.withCredentials = true;
})

.config(function($ionicConfigProvider, $translateProvider) {

  $translateProvider
    .useStaticFilesLoader({
      prefix: 'scripts/locales/',
      suffix: '.json'
    })
    .registerAvailableLanguageKeys(['en', 'cn', 'tw'], {
      'en':'en', 'en_GB':'en', 'en_US':'en', "en_AU":'en', 'en_CA':'en', 'en_NZ':'en', 'en_IE':'en', 'en_ZA':'en', 'en_JM':'en',
      'cn':'cn', 'zh_CN':'cn',
      'zh':'tw', 'tw':'tw', 'zh_TW':'tw', 'zh_HK':'tw', 'zh_SG':'tw'
    })
    .preferredLanguage('cn')
    .determinePreferredLanguage()
    .fallbackLanguage('cn')
    .useSanitizeValueStrategy('escapeParameters');

  $ionicConfigProvider.views.maxCache(4);
  $ionicConfigProvider.tabs.position('bottom');
  $ionicConfigProvider.backButton.text('').icon('ion-android-arrow-back');
  $ionicConfigProvider.backButton.previousTitleText(false);
  $ionicConfigProvider.views.transition('none');
  $ionicConfigProvider.navBar.alignTitle('center');

  if (!ionic.Platform.isIOS()) {
    $ionicConfigProvider.scrolling.jsScrolling(false);
    //$ionicConfigProvider.scrolling.jsScrolling(true);
  }
})

.filter('unsafe', function($sce) { return $sce.trustAsHtml; })


.config(function($mdGestureProvider) {
  $mdGestureProvider.skipClickHijack();
})

.config(function($ionicConfigProvider) {
$ionicConfigProvider.views.swipeBackEnabled(false);
})


.config(function($httpProvider, $stateProvider, $urlRouterProvider, $ionicFilterBarConfigProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
  .state('home', {
    url: "/home",
    abstract: false,
    authenticate : false,
    templateUrl: "templates/home.html"
  })

  .state('account', {
    url: "/account",
    abstract: false,
    authenticate : false,
    templateUrl: "templates/account.html"
  })

  .state('invitation', {
    url: "/invitation",
    abstract: false,
    templateUrl: "templates/account-signup.html"
  })

  .state('tab', {
    url: "/tab",
    abstract: false,
    templateUrl: "templates/tabs.html"
  })

  // Each tab has its own nav history stack:



  .state('tab.topics', {
    url: '/dash',
    views: {
      'tab-topics': {
        templateUrl: 'templates/topics.html',
        controller: 'TopicsCtrl'
      }
    }
  })

  .state('tab.profile', {
    url: '/profile/:profileId',
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile.html',
        controller: 'ProfileCtrl'
      }
    }
  })

  .state('tab.player-profile', {
    url: '/player-profile/:profileId',
    views: {
      'tab-topics': {
        templateUrl: 'templates/profile.html',
        controller: 'ProfileCtrl'
      }
    }
  })


  .state('tab.activity-profile', {
    url: '/activity-profile/:profileId',
    views: {
      'tab-activity': {
        templateUrl: 'templates/profile.html',
        controller: 'ProfileCtrl'
      }
    }
  })

  .state('tab.search-profile', {
    url: '/search-profile/:profileId',
    views: {
      'tab-search': {
        templateUrl: 'templates/profile.html',
        controller: 'ProfileCtrl'
      }
    }
  })

 .state('tab.host-request', {
    url: '/host-request',
    views: {
       'tab-profile': {
         templateUrl: 'templates/host-request.html',
         controller: 'HostRequestCtrl'
       }
     }
  })



/*
  .state('tab.follower', {
    url: "/list-follower",
    templateUrl: "templates/list-follower.html"
  })

 .state('tab.follower', {
    url: '/list-follower',
    views: {
       'tab-profile': {
         templateUrl: 'templates/list-follower.html',
         controller: 'ListFollowerCtrl'
       }
     }
  })

 .state('tab.followering', {
    url: '/list-followering',
    views: {
       'tab-profile': {
         templateUrl: 'templates/list-followering.html',
         controller: 'ListFollowerCtrl'
       }
     }
  })
*/

  .state('tab.setting', {
    url: "/setting",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-setting.html'
      }
    }
  })

  .state('tab.edit-profile', {
    url: "/edit-profile",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-edit.html'
      }
    }
  })

  .state('tab.change-password', {
    url: "/change-password",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-change-password.html'
      }
    }
  })

  .state('tab.verification', {
    url: "/verification",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-verification.html'
      }
    }
  })


  .state('tab.push-notification', {
    url: "/push-notification",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-push-notification.html'
      }
    }
  })

  .state('tab.language', {
    url: "/language",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-language.html'
      }
    }
  })

  .state('tab.country', {
    url: "/country",
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-country.html'
      }
    }
  })


  .state('tab.post-top100', {
    url: '/post-top100/:topicId',
    views: {
      'tab-topics': {
        templateUrl: 'templates/post-top100.html',
        controller: 'TopicPostsCtrl'
      }
    }
  })


  .state('tab.post-latest', {
    url: '/post-latest/:topicId',
    views: {
      'tab-topics': {
        templateUrl: 'templates/post-latest.html',
        controller: 'TopicPostsCtrl'
      }
    }
  })

  .state('tab.post-friends', {
    url: '/post-friends/:topicId',
    views: {
      'tab-topics': {
        templateUrl: 'templates/post-friends.html',
        controller: 'TopicPostsCtrl'
      }
    }
  })

  .state('tab.post-random', {
    url: '/post-random/:topicId',
    views: {
      'tab-topics': {
        templateUrl: 'templates/post-random.html',
        controller: 'TopicPostsCtrl'
      }
    }
  })

  .state('tab.activity', {
      url: '/activity',
      views: {
        'tab-activity': {
          templateUrl: 'templates/tab-activity.html',
          controller: 'ActivityCtrl'
        }
      }
    })

/*
  .state('tab.friends', {
      url: '/friends',
      views: {
        'tab-friends': {
          templateUrl: 'templates/tab-friends.html',
          controller: 'FriendsCtrl'
        }
      }
    })
*/


  .state('tab.search', {
    url: '/search',
    views: {
      'tab-search': {
        templateUrl: 'templates/tab-search.html',
        controller: 'SearchCtrl'
      }
    }
  })



    //$urlRouterProvider.otherwise('/friends');

    //You can override the config such as the following

    /*
    $ionicFilterBarConfigProvider.theme('calm');
    $ionicFilterBarConfigProvider.clear('ion-close');
    $ionicFilterBarConfigProvider.search('ion-search');
    $ionicFilterBarConfigProvider.backdrop(false);
    $ionicFilterBarConfigProvider.transition('vertical');
    $ionicFilterBarConfigProvider.placeholder('Filter');
    */
 // })

    .state('tab.discover', {
      url: '/discover',
      views: {
        'tab-discover': {
          templateUrl: 'templates/tab-discover.html',
          controller: 'DiscoverCtrl'
        }
      }
    })

/*
  .state('tab.account', {
    url: '/account',
    views: {
      'tab-account': {
        templateUrl: 'templates/tab-account.html',
        controller: 'AccountCtrl'
      }
    }
  });
*/
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/home');

});
