angular.module('starter.controllers', [])

.controller('TopicsCtrl', function($scope, $rootScope, $mdToast, $filter, $ionicHistory, $ionicModal, $ionicLoading, $state, $stateParams, Topics, Constants) {

  //$rootScope.hideTabs = false;
  $scope.parentFolder = function(e) { $rootScope.parentFolder = e; }
  $scope.iframeHeight = window.innerWidth;
  //$scope.iframeHeight = $ionicModal.innerWidth;
  $scope.baseUrl = Constants.IMG.baseUrl;

  var $tran = $filter('translate');

  $scope.pageReloadTopics = function() {
    $ionicHistory.clearCache();
    $ionicHistory.clearHistory();
    $state.go($state.current.name, '', {reload:true, inherit:false, notify:true});
  }

  $scope.showActionToast = function() {
    var toastMessage = $mdToast.simple().content($tran('DELETE-POST')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(2000);
    $mdToast.show(toastMessage).then(function(response) {
      if (response == 'ok') {
        $mdToast.hide();
      }
    })
  };

  $scope.$on('$ionicView.beforeEnter', function() {
    $rootScope.top100PostsLoaded = false;
    $rootScope.latestPostsLoaded = false;
    $rootScope.friendPostsLoaded = false;
    $rootScope.randomPostsLoaded = false;
    $ionicHistory.clearCache();
  });

  $scope.goTop100 = function (id) {
    $ionicHistory.nextViewOptions({disableBack: true});
    $state.go('tab.post-top100', {topicId:id});
  };

  $scope.loadingShow = function() {
    //alert('show loading');
    $ionicLoading.show({
      content: $tran('LOADING'),
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      delay:0
    });
  }

  $scope.loadingHide = function(){
      $ionicLoading.hide();
  }

  $scope.loadingShow();

  Topics.query().$promise.then(function(topics) {
    $scope.topics = topics;
    console.log ('topics:' + topics);
    $scope.loadingHide();
  });

  $scope.doRefreshTopics = function() {
    //$ionicHistory.clearCache();
    //$ionicLoading.show({ template: $tran('LOADING') });
    Topics.query().$promise.then(function(topics) {
      $scope.topics = topics;
      $scope.$broadcast('scroll.refreshComplete');
      $scope.$apply();
      $scope.loadingHide();
    });
    //$ionicLoading.hide();
  };

  function updateToast() {
    // only check for toast messages when in topics tab
    if ($location.$$path == "/tab/dash") {
      Toasts.query().$promise.then(function(t) {
        if (t.length == 1) {
          var toastMessage = $mdToast.simple().content(t[0].message).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
          $mdToast.show(toastMessage).then(function(response) {
            if (response == 'ok') {
              console.log("ok clicked");
              $mdToast.hide();
            }
          });
        };
      });
    };
  }
})


.controller('TopicPostsCtrl', function($window, $scope, $ionicNavBarDelegate, $rootScope, $mdToast, $filter, Posts, Post, Topics, Topic, Comments, Comment, Like, $ionicActionSheet, $timeout, $cordovaCamera, $ionicModal, $ionicHistory, $ionicLoading, $q, $state, $stateParams, $ionicScrollDelegate, $ionicListDelegate, $http, Constants) {

  var $tran = $filter('translate');

  $scope.showCameraButton = false;
  $rootScope.lastTopicId = $stateParams.topicId;
  $scope.topicId = $stateParams.topicId;
  $scope.baseUrl = Constants.IMG.baseUrl;
  $scope.currentPage = 1;

  $scope.changeParentFolder = function(e) { $rootScope.parentFolder = e; };

  $scope.loadMorePost = function() {

    console.log('loading more posts');

    if ($scope.isLoading) {
      $scope.$broadcast('scroll.infiniteScrollComplete');
      return null;
    };

    $scope.isLoading = true;
    $scope.currentPage += 1;

    var params = {topicId:$stateParams.topicId, page:$scope.currentPage};

    if ($state.current.name == "tab.post-top100") {
      params.list_type = 'top100';
    } else if ($state.current.name == "tab.post-latest") {
      params.list_type = 'latest';
    } else if ($state.current.name == "tab.post-friends") {
      params.list_type = 'friends';
    } else if ($state.current.name == "tab.post-random") {
      params.list_type = 'random';
    }

    Posts.query(params).$promise.then(function(posts){
      $scope.posts = $scope.posts.concat(posts);
      if ($scope.posts.length >= $scope.totalPosts) {
        $scope.hasMorePost = false;
      }
      $scope.isLoading = false;
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }, function() {
      alert($tran('GENERIC-ERROR-MSG'));
      $scope.isLoading = false;
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  $scope.doRefreshPost = function() {

    if ($scope.isLoading) {
      return null;
    };

    console.log("########## reloaded ##########");
    $rootScope.$broadcast('loading:show');
    $scope.canReload = false;
    $scope.currentPage = 1; //reset to first page
    $scope.isLoading = true;

    var params = {topicId:$stateParams.topicId, page:$scope.currentPage};

    Topic.get({id:$stateParams.topicId}).$promise.then(function(topic) {
      $scope.topic = topic;
      $scope.master_post = topic.master_post;

      if ($state.current.name == "tab.post-top100") {
        params.list_type = 'top100';
        $rootScope.top100PostsLoaded = true;
      } else if ($state.current.name == "tab.post-latest") {
        params.list_type = 'latest';
        $rootScope.latestPostsLoaded = true;
      } else if ($state.current.name == "tab.post-friends") {
        params.list_type = 'friends';
        $rootScope.friendPostsLoaded = true;
      } else if ($state.current.name == "tab.post-random") {
        params.list_type = 'random';
        $rootScope.randomPostsLoaded = true;
      }
      Posts.query(params, function(posts, respHeaders){
        $scope.totalPosts = respHeaders('total');
        $scope.hasMorePost = ($scope.totalPosts > posts.length);
        $scope.posts = posts;
        $scope.showCameraButton = true;
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
        $rootScope.$broadcast('loading:hide');
      });
      $timeout(function() {
        $scope.canReload = true;
      }, 60000*30);
    }, function() {
      alert($tran('GENERIC-ERROR-MSG'));
      $scope.$broadcast('scroll.refreshComplete');
      $rootScope.$broadcast('loading:hide');
    });
  };

  $scope.$on('$ionicView.beforeEnter', function() {
    $ionicNavBarDelegate.showBar(true);
    if (($state.current.name == "tab.post-top100" && !$rootScope.top100PostsLoaded) ||
        ($state.current.name == "tab.post-latest" && !$rootScope.latestPostsLoaded) ||
        ($state.current.name == "tab.post-friends" && !$rootScope.friendPostsLoaded) ||
        ($state.current.name == "tab.post-random" && !$rootScope.randomPostsLoaded)) {
      $scope.posts = [];
      $scope.doRefreshPost();
    }
  });

  $scope.enableOverflowScroll = ionic.Platform.isAndroid();
  $scope.iframeHeight = window.innerWidth;

  $scope.addNewPost = function(postModel, ionicModal) {
    console.log("postModel: ", postModel);
    var post = new Post({topicId:$stateParams.topicId, post:{context: postModel.caption, photo: postModel.canvas}});
    $rootScope.$broadcast('loading:show');

    var error = function(error){
      if(Constants.DEBUGMODE){
        console.log("addNewPost failed");
        console.log(error);
        console.log(error.status_code)
      };

      $rootScope.$broadcast('loading:hide');
      ionicModal.remove();

      var toastMessage = $mdToast.simple().content($tran('POST-ADD-FAILED-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(8000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          //alert('click ok')
          $mdToast.hide();
        }
      });
    }

    var success = function(response){
      if (Constants.DEBUGMODE){
        console.log("addNewPost successful")
        console.log(response);
      }

      // $scope.posts.push(p);
      $rootScope.$broadcast('loading:hide');
      ionicModal.remove();
      $scope.topic.played = true;

      var toastMessage = $mdToast.simple().content($tran('POST-ADD-SUCCESS-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(8000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
         $mdToast.hide();
        }
      });
      $ionicHistory.clearCache();
      //$ionicHistory.nextViewOptions({disableBack:true, historyRoot:true});
      //$state.go('tab.post-latest', {topicId: $stateParams.topicId});
      var landing_page = 'tab.post-latest';
      $rootScope.$broadcast('posts:updated');
      //if ($state.current.name == 'tab.post-top100') landing_page = 'tab.post-latest';
      $state.go(landing_page, {topicId:$scope.topicId}, { reload: true, inherit: false, notify: true });
      $ionicHistory.nextViewOptions({disableBack: true});
    }
    post.$save().then(success, error);
  };

  $scope.togglePostLike = function(post) {
    console.log("$scope.posts:", $scope.posts);
    var like = new Like({postId:post.id, like:{post_id:post.id}});
    like.$save().then(function(p) {
      post.liked = p.liked;
      post.likes_count = p.likes_count;
    });
  };

  $scope.postMoreShow = function(post) {

    if (post.poster.id == $rootScope.myProfile.id) {
      if (post.is_master_post ) {
        actions = [];
      } else {
        actions = [{ text: '<span class=calm>' + $tran('DELETE-POST-BTN') + '</span>' }];
      }
    } else {
      actions = [{ text: '<span class=assertive>' + $tran('REPORT-BTN') + '</span>' }];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: actions,

      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
          // add cancel code..
      },
      buttonClicked: function(index) {
        console.log(index);
        if (index==0) {
          if (post.poster.id == $rootScope.myProfile.id) {
            $scope.disablePost(post);
            hideSheet();
          } else {
            $scope.reportAbuse(post);
            hideSheet();
          }
        }
      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() {
      hideSheet();
    }, 5000);
  };

  $scope.reportAbuse = function(post) {
    var post = new Post({id:post.id});
    $rootScope.$broadcast('loading:show');
    post.$abuse().then(function(p) {
      $rootScope.$broadcast('loading:hide');
      var toastMessage = $mdToast.simple().content($tran('REPORTED-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          $mdToast.hide();
       }
      });
    });
  };

  $scope.disablePost = function(post) {
    var post = new Post({id:post.id});
    $ionicLoading.show({
      template: $tran('DELETING-MSG')
    });
    post.$delete().then(function(p) {
      console.log(p);
      //$ionicLoading.hide();
      $ionicHistory.clearCache();

      //$state.go($state.current.name, {topicId:$scope.topicId});
      //$state.go($state.current.name, {topicId:$scope.topicId}, { reload: true, inherit: false, notify: true });

      //tab.post-latest, tab.post-top100
      $ionicLoading.hide();
      $scope.topic.played = false;

      //$window.location.reload(true);
      var toastMessage = $mdToast.simple().content($tran('DELETE-POST-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          $mdToast.hide();
        }
      });

      var landing_page = 'tab.post-latest';
      $rootScope.$broadcast('posts:updated');
      $state.go(landing_page, {topicId:$scope.topicId}, { reload: true, inherit: true, notify: true });
      $ionicHistory.nextViewOptions({disableBack: true});

    });
  };

  $scope.openCameraSelection = function(callback) {
    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: '<span class=calm>' + $tran('TAKE-PHOTO-BTN') + '</span>' },
        { text: '<span class=calm>' + $tran('CHOOSE-FROM-GALLERY-BTN') + '</span>' }
      ],

      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        if (index==0) {
          $scope.takePhoto(callback);
          hideSheet();
        } else if (index==1) {
          $scope.choosePhoto(callback);
          hideSheet();
        }
        return true;
      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() { hideSheet(); }, 5000);
  };

  $scope.redeemCollage = function() {
    var appVersion = "0.0.0";
    var topic = new Topic({id:$stateParams.topicId});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    topic.$redeem({appVersion:$rootScope.appVersion}).then(function(r) {
      console.log(r);
      $ionicLoading.hide();
      var toastMessage = $mdToast.simple().content(r.message).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
        $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          console.log("ok clicked");
          $mdToast.hide();
        }
      });
    }, function(error) {
      console.log(r);
      $ionicLoading.hide();
      var toastMessage = $mdToast.simple().content(r.message).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
        $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          console.log("ok clicked");
          $mdToast.hide();
        }
      });
    });
  };

  $scope.sttButton=false;
  $scope.lastPosition=0;

  $scope.scrollToTop = function() { //ng-click for back to top button
    $scope.lastPosition = $ionicScrollDelegate.getScrollPosition().top;
    $ionicScrollDelegate.scrollTop(true);
    $scope.sttButton=false;  //hide the button when reached top
  };

  $scope.scrollToOrigin = function() { //ng-click for back to top button
    //console.log('last position:' + $scope.lastPosition);
    $ionicScrollDelegate.scrollTo(0,$scope.lastPosition,true);
    //$scope.lastPosition=0;
    $scope.sttButton=true;  //hide the button when reached top
  };


  $scope.scrollPos = "";

  $scope.getScrollPosition = function() {

  $scope.scrollPos = $ionicScrollDelegate.getScrollPosition().top;

  //monitor the scroll
   //var moveData = $ionicScrollDelegate.getScrollPosition().top;
    //console.log(moveData);
     $scope.$apply(function(){
       if($scope.scrollPos>300){
            //alert('ggg');
         $scope.sttButton=true;
       }else{
         $scope.sttButton=false;
       }
    return $scope.sttButton;
     }); //apply

   };  //getScrollPosition


  $scope.showScrollTopButton = function () {
    $scope.scrollPos = $ionicScrollDelegate.getScrollPosition().top;
    //console.log($scope.scrollPos);
       if($scope.scrollPos>300){
            //alert('aaa');
         $scope.sttButton=true;
       }else{
         $scope.sttButton=false;
       }
    return $scope.sttButton;
  }

  $scope.showScrollDownButton = function () {
    $scope.scrollPos = $ionicScrollDelegate.getScrollPosition().top;
    //console.log($scope.scrollPos);
       if($scope.scrollPos<300 && $scope.lastPosition>299){
            //alert('ggg');
         $scope.sttButton=true;
       }else{
         $scope.sttButton=false;
       }
    return $scope.sttButton;
  }

  $scope.newComment = function(commentModel) {
    commentModel.post_id = $scope.post.id;
    var comment = new Comment({postId:$scope.post.id, comment:commentModel});
    comment.$save().then(function(c) {
      console.log("$scope.posts:", $scope);
      $scope.comments.push(c);
      commentModel.messages = "";
      if ($scope.post.is_master_post) {
        $scope.master_post = c.post;
      } else {
        for (var i in $scope.posts) {
          if ($scope.posts[i].id == c.post.id) {
            $scope.posts[i] = c.post;
            break; //Stop this loop, we found it!
          }
        }
      }
    });
  };

  $scope.openPostComment = function(post, showKeyboard) {
    $scope.post = post;
    $rootScope.post = post;
    $scope.comments = Comments.query({postId:post.id});
    console.log("openPostComment:", $rootScope.post);

    if ($window.cordova) $window.cordova.plugins.Keyboard.disableScroll(true);

    $ionicModal.fromTemplateUrl('post-comment.html', {
      // Use our scope for the scope of the modal to keep it simple
      scope: $scope,
      // The animation we want to use for the modal entrance
      //animation: 'slide-in-up',
      animation: 'none',
      focusFirstInput: showKeyboard,
      hardwareBackButtonClose: true
    }).then(function(modal) {
      $scope.postComment = modal;
      $scope.postComment.show();
      if (showKeyboard && $window.cordova) $window.cordova.plugins.Keyboard.show();
    });
  };

  console.log($rootScope);

  $scope.closePostComment = function() {
    if ($window.cordova) window.cordova.plugins.Keyboard.close();
    $scope.postComment.remove();
  };
    //Cleanup the modal when we're done with it!

  var initPC = function (showKeyboard) {
    if ($scope.postComment) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('post-comment.html', {
          // Use our scope for the scope of the modal to keep it simple
          scope: $scope,
          // The animation we want to use for the modal entrance
          //animation: 'slide-in-up',
          animation: 'none',
          focusFirstInput: showKeyboard,
          hardwareBackButtonClose: true
        }).then(function(modal) {
          $scope.postComment = modal;
        });
            //Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
          $scope.postComment.remove();
        });
        // Execute action on hide modal
        $scope.$on('postComment.hidden', function() {
          // Execute action
          $scope.closePostComment();
        });
        // Execute action on remove modal
        $scope.$on('postComment.removed', function() {
          // Execute action
          $scope.closePostComment();
        });

        $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
          $scope.postComment.remove();
        });
    }
  }

  $scope.goTop100 = function (id) {
    $state.go('^.post-top100', {topicId:id}, { reload: true, inherit: false, notify: true });
    $ionicHistory.nextViewOptions({disableBack: true});
  }
  $scope.goLatest = function (id) {
    $state.go('^.post-latest', {topicId:id}, { reload: true, inherit: false, notify: true });
    $ionicHistory.nextViewOptions({disableBack: true});
  }
  $scope.goFriends = function (id) {
    $state.go('^.post-friends', {topicId:id}, { reload: true, inherit: false, notify: true });
    $ionicHistory.nextViewOptions({disableBack: true});
  }
  $scope.goRandom = function (id) {
    $state.go('^.post-random', {topicId:id}, { reload: true, inherit: false, notify: true });
    $ionicHistory.nextViewOptions({disableBack: true});
  }

  $scope.showGoToTopicButton = function() {
    if ($state.current.name == 'tab.post-top100' || $state.current.name == 'tab.post-latest' || $state.current.name == 'tab.post-friends' || $state.current.name === 'tab.post-random') {
//|| $ionicHistory.backTitle() == $ionicHistory.currentTitle()
      if ($ionicHistory.backTitle() == null || $ionicHistory.backTitle() == $ionicHistory.currentTitle()) {
        console.log('show topic button :'+ $ionicHistory.backTitle() + '|' + $ionicHistory.currentTitle());
        return true;
      } else {
        console.log('hide topic button: '+ $ionicHistory.backTitle() + '|' + $ionicHistory.currentTitle())
        return false;
      }
    }
  }

  $scope.goToTopicButton = function () {
    console.log('click goToTopicButton and clear cache');
    $ionicHistory.clearCache();
    $ionicHistory.nextViewOptions({disableBack:true, historyRoot:true});
    $state.go('tab.topics');
  }

  $scope.scrollBottom = function (delegate){
    //$ionicScrollDelegate.scrollBottom(true);
    $ionicScrollDelegate.$getByHandle(delegate).scrollBottom(true);
    console.log ('post comment scroll bottom');
  };

  // if ($window.cordova) $window.cordova.plugins.Keyboard.disableScroll(true); // true for ios only, false for other os
  // if (ionic.Platform.isIOS()) cordova.plugins.Keyboard.disableScroll(true);

  $scope.pageReload = function() {
    //alert('dd');
    $ionicHistory.clearCache();
    //$state.reload(true);
    //alert($stateParams.topicId);
    //$state.go($state.current.name, '', {reload:true, inherit:true, notify:true});
    $state.go($state.current.name, {topicId: $stateParams.topicId}, {reload:true, notify:true});
  }

  function showToast(msg) {
    var el = angular.element(document.getElementById('post-comment-modal'));
    var toastMessage = $mdToast.simple().content(msg).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(3000).parent(el);
    $mdToast.show(toastMessage);
  }

  function reportCommentAbuse(commentId, msg) {
    var comment = new Comment({id:commentId});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    comment.$abuse().then(function(p) {
      console.log(msg, p);
      $ionicLoading.hide();
      showToast(msg)
    });
  };

  function removeComment(comment, msg) {
    var comment = new Comment({id:comment.id});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    comment.$delete().then(function(p) {
      console.log(msg, p);
      console.log($scope.post.comments);
      for (var i in $scope.comments) {
        console.log("i: ", i, ", comment.id: ", comment.id)
        if ($scope.comments[i].id == comment.id) {
          console.log("COMMENT FOUND IN COMMENTS LIST!!!!");
          $scope.comments.splice(i, 1);
          break; //Stop this loop, we found it!
        }
      };
      for (var i in $scope.post.comments) {
        console.log("i: ", i, ", comment.id: ", comment.id)
        if ($scope.post.comments[i].id == comment.id) {
          console.log("COMMENT FOUND IN POST COMMENT!!!!");
          $scope.post.comments.splice(i, 1);
          break; //Stop this loop, we found it!
        }
      };
      $ionicLoading.hide();
      showToast(msg);
    });
  };

  $scope.reportCommentShow = function(comment) {
    console.log($scope.post);
    // Show the action sheet
    if ($scope.post.is_admin)
      if (comment.user_id == $scope.post.poster.id)
        var buttons = [
          { text: '<span class=assertive>' + $tran('DELETE-BTN') + '</span>' }
        ];
      else
        var buttons = [
          { text: '<span class=assertive>' + $tran('DELETE-AND-REPORT-BTN') + '</span>' }
        ];
    else
      var buttons = [
        { text: '<span class=assertive>' + $tran('REPORT-ABUSE-BTN') + '</span>' }
      ];

    var hideSheet = $ionicActionSheet.show({

      buttons: buttons,
      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
          // add cancel code..
      },
      buttonClicked: function(index) {
        $ionicListDelegate.closeOptionButtons();
        hideSheet();
        console.log(index);
        var lblTemplate = '';
        var lblTitle = "";
        var lblActionButton = $tran('DISMISS-BTN');

        if ($scope.post.is_admin)
          if (comment.user_id == $scope.post.user_id)
            removeComment(comment, $tran('COMMENT-DELETED-MSG'));
          else
            removeComment(comment, $tran('COMMENT-REPORTED-AND-DELETED-MSG'));
        else
          reportCommentAbuse(comment.id, $tran('REPORTED-MSG'));

      }
    });
  }
})

.controller("CameraCtrl", function($scope, $rootScope, $state, $cordovaCamera, $stateParams) {

})

.controller('PostCommentCtrl', function($window, $scope, $rootScope, $filter, Comments, Comment, $ionicScrollDelegate) {
  // $scope.post and $scope.comments are inherited from parent scope
  $scope.parentFolder = function(e) { $rootScope.parentFolder = e; };
  console.log('PostCommentCtrl.init: ', $rootScope.post);

  $scope.newComment = function(commentModel) {
    console.log("$rootScope.post in PostCommentCtrl:", $scope.post);
    commentModel.post_id = $scope.post.id;
    var comment = new Comment({postId:$scope.post.id, comment:commentModel});
    comment.$save().then(function(c) {
      console.log("$scope.$parent.$parent.$parent.posts:", $scope);
      $scope.comments.push(c);
      commentModel.messages = "";
      if ($scope.post.is_master_post) {
        $scope.$parent.$parent.$parent.master_post = c.post;
      } else {
        for (var i in $scope.$parent.$parent.$parent.posts) {
          console.log("i: ", i, ", c.post.id: ", c.post.id)
          if ($scope.$parent.$parent.$parent.posts[i].id == c.post.id) {
            console.log("FOUND!!!!");
            $scope.$parent.$parent.$parent.posts[i] = c.post;
            break; //Stop this loop, we found it!
          }
        }
      }
    });
  };

  if (!$rootScope.parentFolder) $scope.parentFolder = "player-profile";
  // if ($window.cordova) $window.cordova.plugins.Keyboard.disableScroll(true); // true for ios only, false for other os
  // if (ionic.Platform.isIOS()) cordova.plugins.Keyboard.disableScroll(true);
  // $scope.parentFolder = "player-profile";

})

.controller('BackButtonCtrl', function($scope, $ionicNavBarDelegate, $state, $ionicHistory) {

  //$ionicNavBarDelegate.showBackButton(true);
  //alert($ionicNavBarDelegate.showBackButton());
  //$ionicNavBarDelegate.showBar(true);
  //alert($ionicNavBarDelegate.showBackButton());
  $scope.showBackButton = true;
  if ($state.current.name == 'tab.post-top100' || $state.current.name == 'tab.post-latest' || $state.current.name == 'tab.post-friends' || $state.current.name === 'tab.post-random') {
    //alert($state.current.name)
    $scope.showBackButton = false;
  }

  $scope.myGoBack = function() {
    //alert('click myGoBack');
    if ($state.current.name == 'tab.post-top100' || $state.current.name == 'tab.post-latest' || $state.current.name == 'tab.post-friends' || $state.current.name === 'tab.post-random') {
      console.log('go to tab.topics');
      $ionicHistory.nextViewOptions({disableBack:true, historyRoot:true});
      $state.go('tab.topics');
    } else {
      console.log('go to previous page');
      $ionicHistory.goBack();
    }
  };


})

.controller('AccountCtrl', function($window, $ionicPlatform, $ionicHistory, $ionicLoading, $ionicPopup, $timeout, $scope, $state, $stateParams, $filter, $localstorage, $translate, Profile, Constants, AuthService, $ionicModal, $rootScope, $q) {

  console.log('AccountCtrl loaded');

  $scope.showAccountFooter = true;
  var $tran = $filter('translate');

  $localstorage.set('language', $translate.use());

  AuthService.ping('AccountCtrl').then(function(resp) {
    if(Constants.DEBUGMODE) {
      console.log('AuthService.ping response: ', resp);
    }
    $rootScope.myProfile = resp;
    $ionicLoading.hide();
    if (resp.is_username_set) {
      $ionicHistory.clearCache();
      $ionicHistory.clearHistory();
      $state.go('tab.topics');
    } else
      $state.go('invitation');
    event.preventDefault();
  }, function(error) {
    console.log('AccountCtrl error: ', error);
    $state.go('account');
  });

  $scope.capitalize = function (s) {
    return s[0].toUpperCase() + s.slice(1);
  }

  // not authenticated
  $scope.user = {};

  var initAccountLogin = function () {
    if ($scope.accountLogin) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('account-login.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-to-left',
        hardwareBackButtonClose: true
      }).then(function(accountLogin) {
        $scope.accountLogin = accountLogin;
      });
      $scope.$on('$destroy', function() {
        //alert('acc $destroy');
        $scope.accountLogin.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        //alert('acc hide');
        // Execute action

      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        //alert(' acc removed');
        // Execute action
      });
    }
  };

  $scope.openAccountLogin = function() {
    initAccountLogin().then(function () {
      $scope.accountLogin.show();
    });
  };

  $scope.closeAccountLogin = function() {
    $scope.accountLogin.hide();
  };

  $scope.authenticateUser = function(provider, isFromSignUp){
    if(Constants.DEBUGMODE){
      console.log("AuthenticateUser started");
    }

    var error = function(error){
      $ionicLoading.hide();

      if(Constants.DEBUGMODE){
        console.log("AuthenticateUser failed");
        console.log(error);
      }

      $scope.error = error;

      var errorPopup = $ionicPopup.show({
        //template: '<p style="paing:10px; text-align: center;">' + error.message + '</p>',
        template: '<p style="padding:5px; text-align: center;">' + $tran('LOGIN-FAILED-MSG') + '</p>',
        title: $tran('OOPS'),
        scope: $scope,
        buttons: [
          { text: $tran('TRY-AGAIN-BTN') }
        ]
      });

      errorPopup.then(function(res) {
        if(Constants.DEBUGMODE) {
          console.log('Popup close button Tapped!', res);
        }
      });

      $timeout(function() {
        errorPopup.close(); //close the popup after 3 seconds for some reason
      }, 5000);
    }

    var success = function(response){
      // if the authentication is successful go to profile view
      if (Constants.DEBUGMODE){
        console.log("Authentication successful")
        console.log(response);
      }

      console.log('authenticateUser :: ', response);
      $ionicLoading.hide();
      if (isFromSignUp) {

      } else {
        if ($scope.accountLogin) {
          $scope.closeAccountLogin();
        }
        $ionicHistory.clearCache();
        $ionicHistory.clearHistory();
        console.log('response.username: ', response.username);
        console.log('response.email: ', response.email);
        if (response.is_username_set) {
          $state.go('tab.topics');
        } else {
          $scope.user = response;
          $state.go('invitation');
        }
      }
    }

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    // use AuthService to login
    AuthService.login($scope.user, provider).then(success,error);
  };

  $scope.registerUser = function(){
    var success = function(response){
      if(Constants.DEBUGMODE){
        console.log("Registering user successful");
        console.log(response);
      }
      $ionicLoading.hide();
      $scope.authenticateUser(null, true);
      $state.go('invitation');
    }

    var error = function(error){
      $ionicLoading.hide();
      if(Constants.DEBUGMODE){
        console.log(error);
      }
      $scope.error = error;
      error_message = "";
      console.log(error);
      for (var e in error.errors) {
        error_message += error.errors[e][0] + "<br/>";
      }

      var errorPopup = $ionicPopup.show({
          template: '<p style="padding:10px; text-align: center;">' + $scope.capitalize(error_message) + '</p>',
          //template: '<p style="padding:5px; text-align: center;">' + error_message + '|The login information you entered are invalid, please check and try again now.</p>',
          title: $tran('OOPS'),
          scope: $scope,
          buttons: [
              { text: $tran('TRY-AGAIN-BTN') }
          ]
        });

      errorPopup.then(function(res) {
        if(Constants.DEBUGMODE){
          console.log('popup ok Tapped!', res);
        }
      });

      $timeout(function() {
        errorPopup.close(); //close the popup after 10 seconds for some reason
      }, 10000);
    }

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    AuthService.register($scope.user).then(success,error);
  };

  $scope.openIntellectualProperty = function() {
    $ionicModal.fromTemplateUrl('intellectual-property.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.intellectualProperty = modal;
        $scope.intellectualProperty.show();
      });
  };

  $scope.closeIntellectualProperty = function() {
    $scope.intellectualProperty.remove();
  };


  $scope.openCommunityGuidelines = function() {
    $ionicModal.fromTemplateUrl('community-guidelines.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.communityGuidelines = modal;
        $scope.communityGuidelines.show();
      });
  };

  $scope.closeCommunityGuidelines = function() {
    $scope.communityGuidelines.remove();
  };


  $scope.openPrivacyPolicy = function() {
    $ionicModal.fromTemplateUrl('privacy-policy.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.privacyPolicy = modal;
        $scope.privacyPolicy.show();
      });
  };

  $scope.closePrivacyPolicy = function() {
    $scope.privacyPolicy.remove();
  };
  //Cleanup the modal when we're done with it!

  $scope.openTermPolicy = function() {
    initTP().then(function () {
      $scope.termPolicy.show();
    });
  };

  $scope.closeTermPolicy = function() {
    $scope.termPolicy.hide();
  };
  //Cleanup the modal when we're done with it!

  var initTP = function () {
    if ($scope.termPolicy) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('term-policy.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.termPolicy = modal;
      });
    }
  };

  $scope.showPopup = function() {
    $scope.profile = {};
    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      template: '<input type="email" autofocus style="background-color:#eeeeee;padding-left:5px;padding-right:5px;" ng-model="profile.email"><div ng-model="message" ng-cloak>',
      title: $tran('CANT-ACCESS'),
      subTitle: $tran('ENTER-YOUR-EMAIL'),
      cssClass: 'longPopup',
      scope: $scope,
      buttons: [
        { text: $tran('CANCEL-BTN') },
        {
          text: '<b>' + $tran('SEND-BTN') + '</b>',
          type: 'button-calm',
          onTap: function(e) {
            if (!$scope.profile.email) {
              //don't allow the user to close unless he enters valid email
              e.preventDefault();
            } else {

              var profile = new Profile($scope.profile);

              var success = function(response){
                console.log("profile.changePassword resp:", response);
                $scope.profile = response;
                $rootScope.myProfile = response;

                var successPopup = $ionicPopup.show({
                  templateUrl: 'templates/modal/passwordResetComplete.html',
                  title: $tran('PASSWORD-RESET-COMPLETE'),
                  buttons: [
                      { text: $tran('OK-BTN') }
                  ]
                })
              }

              var error = function(error){
                if(Constants.DEBUGMODE){
                  console.log("profile.forgetPassword error:", error);
                }

                if (error.status == 400)
                  message = $tran('RESET-FACEBOOK-PASSWORD-MSG');
                else
                  message = $tran('EMAIL-NOT-REGISTERED-MSG');
                var errorPopup = $ionicPopup.alert({
                  template: '<p style="padding:10px; text-align: center;"> ' + message + ' </p>',
                  title: $tran('OOPS'),
                  scope: $scope,
                  buttons: [
                      { text: $tran('OK-BTN') }
                  ]
                });
              }

              profile.$forgetPassword().then(success, error);
              return $scope.profile.email;
            }
          }
        }
      ]
    })
  }
})

.controller('InvitationCtrl', function($window, $ionicPlatform, $ionicHistory, $ionicLoading, $ionicPopup, $timeout, $scope, $state, $stateParams, $mdToast, $filter, Profile, Constants, AuthService, $ionicModal, $rootScope, $q) {

  console.log('InvitationCtrl loaded');
  var $tran = $filter('translate');

  AuthService.ping('InvitationCtrl').then(function(resp) {
    if(Constants.DEBUGMODE) {
      console.log('AuthService.ping response: ', resp);
    }
    $rootScope.myProfile = resp;
    $ionicLoading.hide();
    if (resp.is_username_set)
      $state.go('tab.topics');
    else
      $scope.user = {username: resp.username, name: resp.name};

  });

  $scope.usernamePattern = (function() {
    var regexp = new RegExp(/^[a-zA-Z0-9._]{2,30}$/);
    return {
        test: function(value) {
            return regexp.test(value);
        }
    };
  })();

  $scope.capitalize = function (s) {
    return s[0].toUpperCase() + s.slice(1);
  };

  $scope.updateUser = function(redirectToTopic){
    $mdToast.hide();
    var success = function(response){
      if(Constants.DEBUGMODE){
        console.log("updateUser successful");
        console.log(response);
      }
      $ionicHistory.clearCache();
      $ionicHistory.clearHistory();
      $ionicLoading.hide();
      if(redirectToTopic == true) {
        $state.go('tab.topics');
      }else{
        $state.go('tab.profile', {profileId:response.id});
      };
    }

    var error = function(error){
      $ionicLoading.hide();
      if(Constants.DEBUGMODE){
        console.log(error);
      }

      error_message = "";
      for (var e in error.data.errors) {
        error_message += error.data.errors[e][0] + "<br/>";
      }

      var errorPopup = $ionicPopup.show({
          template: '<p style="padding:10px; text-align: center;">' + error_message + '</p>',
          //template: '<p style="padding:5px; text-align: center;">' + error_message + '|The login information you entered are invalid, please check and try again now.</p>',
          title: $tran('OOPS'),
          scope: $scope,
          buttons: [
              { text: $tran('TRY-AGAIN-BTN') }
          ]
        });

      errorPopup.then(function(res) {
        if(Constants.DEBUGMODE){
          console.log('popup ok Tapped!', res);
        }
      });

      $timeout(function() {
        errorPopup.close(); //close the popup after 10 seconds for some reason
      }, 10000);
    }

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    $scope.user.is_username_set = true;

    var profile = new Profile({id:0, profile:$scope.user});

    if (window.cordova) {
      window.plugins.OneSignal.getIds(function(ids) {
        $scope.user.platform = ionic.Platform.platform();
        $scope.user.device_id = ids.userId;
        // use AuthService to login
        profile.$save().then(success, error);
      });
    } else {
      profile.$save().then(success, error);
    }


  };

  $scope.checkInvitationCode = function() {
    console.log("checkInvitationCode called");
    var profile = new Profile({profile:$scope.user});
    profile.$checkInvitationCode().then(function (resp) {
      $scope.user.username = resp.username;
    }, function (resp) {
      var errorPopup = $ionicPopup.show({
        template: '<p style="padding:10px; text-align: center;">' + $tran('INVALID-INVITE-CODE-MSG') + '</p>',
        title: $tran('OOPS'),
        scope: $scope,
        buttons: [
            { text: $tran('TRY-AGAIN-BTN') }
        ]
      });

      errorPopup.then(function(res) {
        $scope.user.invitation_code = null;
        $timeout(function () {
          document.getElementById('inviteCode').select();
        }, 0);
        if(Constants.DEBUGMODE){
          console.log('errorPopup ok Tapped!', res);
        }
      });

      $timeout(function() {
        errorPopup.close(); //close the popup after 10 seconds for some reason
      }, 5000);
    });
  };

  $scope.showToast = function(msgId) {
    if (msgId==1) {
      msg = $tran('INVITE-CODE-TOAST');
    } else if (msgId==2) {
      msg = $tran('USERNAME-TOAST');
    } else if (msgId==3) {
      msg = $tran('FULLNAME-TOAST');
    };
    var toastMessage = $mdToast.simple().content(msg).highlightAction(true).position('top').hideDelay(0);
    $mdToast.show(toastMessage);
  };

  $scope.openIntellectualProperty = function() {
    $mdToast.hide();
    $ionicModal.fromTemplateUrl('intellectual-property.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.intellectualProperty = modal;
        $scope.intellectualProperty.show();
      });
  };

  $scope.closeIntellectualProperty = function() {
    $scope.intellectualProperty.remove();
  };


  $scope.openCommunityGuidelines = function() {
    $mdToast.hide();
    $ionicModal.fromTemplateUrl('community-guidelines.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.communityGuidelines = modal;
        $scope.communityGuidelines.show();
      });
  };

  $scope.closeCommunityGuidelines = function() {
    $scope.communityGuidelines.remove();
  };


  $scope.openPrivacyPolicy = function() {
    $mdToast.hide();
    $ionicModal.fromTemplateUrl('privacy-policy.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.privacyPolicy = modal;
        $scope.privacyPolicy.show();
      });
  };

  $scope.closePrivacyPolicy = function() {
    $scope.privacyPolicy.remove();
  };
  //Cleanup the modal when we're done with it!

  $scope.openTermPolicy = function() {
    $mdToast.hide();
    initTP().then(function () {
      $scope.termPolicy.show();
    });
  };

  $scope.closeTermPolicy = function() {
    $scope.termPolicy.hide();
  };
  //Cleanup the modal when we're done with it!

  var initTP = function () {
    if ($scope.termPolicy) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('term-policy.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.termPolicy = modal;
      })
    }
  }
})

.controller('ProfileCtrl', function($scope, $ionicNavBarDelegate, $rootScope, $window, $filter, Profile, Follow, Post, Comments, Comment, Like, $stateParams, $ionicLoading, $ionicModal, $ionicPlatform, $ionicActionSheet, $q, $timeout, $ionicHistory, $ionicScrollDelegate, $ionicListDelegate, Constants, $cordovaSocialSharing, $mdToast, $ionicPopup, $state, $ionicHistory) {

  var $tran = $filter('translate');
  console.log($ionicHistory);

  $scope.$on('$ionicView.beforeEnter', function() {
    $ionicLoading.show({
      template: $tran('LOADING')
    });

    $scope.profileId = $stateParams.profileId;
    $scope.is_myself = $scope.profileId == 0 || ($rootScope.myProfile && $scope.profileId == $rootScope.myProfile.Id);

    Profile.get({id:$scope.profileId}).$promise.then(function(p) {
      $scope.profile = p;
      $scope.profileId = p.id;
      console.log("ProfileCtrl.profile: ", $scope.profile);
      $scope.is_myself = ($scope.profileId == 0 || $scope.profile.is_myself);
      if ($scope.is_myself) {
        $rootScope.myProfile = p;
        console.log("$rootScope.myProfile: ", $rootScope.myProfile);
      };
      $ionicLoading.hide();
    });
  });

  $scope.baseUrl = Constants.IMG.baseUrl;
  //Get it now from " + $rootScope.myProfile.name + " and see how cool you can be !";

  $scope.shareAnywhere = function() {
    var message = $tran('INVITE-TO-COOMUS-1') + "\n" + $tran('INVITE-TO-COOMUS-2') + "\n" + $tran('INVITE-TO-COOMUS-3') + "\n" + $tran('INVITE-TO-COOMUS-4');
    $cordovaSocialSharing.share(message, $tran('INVITATION-TO-COOMUS'), $scope.baseUrl + "/images/coomus.png", "http://www.coomus.com");
  }

  if (!$rootScope.parentFolder || $rootScope.parentFolder == '' || $scope.profileId == 0 || $scope.profileId == '') $rootScope.parentFolder = 'profile';

  //if ($scope.is_myself) $rootScope.parentFolder = 'profile';
  $scope.changeParentFolder = function(e) { $rootScope.parentFolder = e; }
  $scope.parentFolder = $rootScope.parentFolder;
  $scope.hideBackButton = "";

  if ($scope.is_myself) {
    $scope.hideBackButton = "hide";
  }

  $scope.toggleFollow = function(profile) {
    console.log("Profile: ", profile, " followed by ", $rootScope.myProfile);
    var follow = new Follow({profileId:profile.id});
    follow.$save().then(function(p) {
      $scope.profile.is_followed = p.is_followed;
      $scope.profile.followers_count = p.followers_count;
      $scope.profile.following_users_count = p.following_users_count;
    });
  };

  $scope.setProfilePic = function() {

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: '<span class=calm>' + $tran('TAKE-PHOTO-BTN') + '</span>' },
        { text: '<span class=calm>' + $tran('CHOOSE-FROM-GALLERY-BTN') + '</span>' }
      ],
      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        hideSheet();
        console.log(index);
        if (index==0) {
          $scope.takePhotoOnly($scope.uploadProfileAvatar);
        } else if (index==1) {
          $scope.choosePhotoOnly($scope.uploadProfileAvatar);
        }
      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() {  hideSheet();  }, 5000);
  };

  $scope.uploadProfileAvatar = function(canvas) {
    console.log('$scope.uploadProfileAvatar called');
    var profile = new Profile({id:$scope.profileId, profile:{avatar:canvas}});
    $ionicLoading.show({
      template: $tran('LOADING')
    });

    profile.$save().then(function(p) {
      console.log("profile.save resp:", p);
      $ionicLoading.hide();
      $scope.profile = p;
      $rootScope.myProfile = p;
    });
  };


  $scope.openPostDetail = function(postId) {
    //console.log ('parentFolder: '+$scope.parentFolder)
      //$scope.parentFolder = 'profile';
      $scope.changeParentFolder = function(e) { $rootScope.parentFolder = e; }
      console.log ('parentFolder: '+ $scope.parentFolder)
    /*
    initPostDetail(postId).then(function () {
      $scope.postDetail.show();
    */
      $ionicModal.fromTemplateUrl('templates/post-detail.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(postDetail) {
        $scope.postDetail = postDetail;
        $scope.postDetail.show();
      });

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    var post = new Post({id:postId});
    var success = function(response){
      if (Constants.DEBUGMODE){
        console.log("postDetail success: ", response);
      }
      $scope.post = response;
      // $scope.posts.push(p);
      $ionicLoading.hide();
    }
    post.$get().then(success);
  };

  $scope.closePostDetail = function() {
    $scope.postDetail.remove();
  };

  var initPostDetail = function (postId) {
    if ($scope.postDetail) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('templates/post-detail.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(postDetail) {
        $scope.postDetail = postDetail;
      });
      $scope.$on('$destroy', function() {
        $scope.postDetail.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
        $scope.post = closePostDetailnull;
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        //alert(' acc removed');
        // Execute action
      });
    }
  };

  $scope.postMoreShow = function(post) {

    if (post.poster.id == $rootScope.myProfile.id) {
      if (post.is_master_post ) {
        actions = [];
      } else {
        actions = [{ text: '<span class=calm>' + $tran('DELETE-POST-BTN') + '</span>' }];
      }
    } else {
      actions = [{ text: '<span class=assertive>' + $tran('REPORT-BTN') + '</span>' }];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: actions,

      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
          // add cancel code..
      },
      buttonClicked: function(index) {
        console.log(index);
        if (index==0) {
          if (post.poster.id == $rootScope.myProfile.id) {
            $scope.disablePost(post);
            hideSheet();
          } else {
            $scope.reportAbuse(post);
            hideSheet();
          }
        }
      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() {
      hideSheet();
    }, 5000);
  };

  $scope.reportAbuse = function(post) {
    var post = new Post({id:post.id});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    post.$abuse().then(function(p) {
      $ionicLoading.hide();
      var toastMessage = $mdToast.simple().content($tran('REPORTED-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          $mdToast.hide();
       }
      });
    });
  };

  $scope.disablePost = function(post) {
    var post = new Post({id:post.id});
    $ionicLoading.show({
      template: $tran('DELETING-MSG')
    });
    post.$delete().then(function(p) {
      console.log(p);
      //$ionicLoading.hide();
      $ionicHistory.clearCache();

      //$state.go($state.current.name, {topicId:$scope.topicId});
      //$state.go($state.current.name, {topicId:$scope.topicId}, { reload: true, inherit: false, notify: true });

      //tab.post-latest, tab.post-top100
      $ionicLoading.hide();

      //$window.location.reload(true);
      var toastMessage = $mdToast.simple().content($tran('DELETE-POST-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          $mdToast.hide();
        }
      });

      $scope.closePostDetail();
      $ionicHistory.nextViewOptions({disableBack: true});
      $rootScope.$broadcast('posts:updated');
      $state.go($state.current.name, {profileId: $stateParams.profileId}, { reload: true });
    });
  };

  $scope.togglePostLike = function(post) {
    console.log("Post: ", post, " liked");
    console.log("$scope.posts:", $scope.posts);
    var like = new Like({postId:post.id, like:{post_id:post.id}});
    like.$save().then(function(p) {
      post.liked = p.liked;
      post.likes_count = p.likes_count;
    });
  };

  $scope.openListFollowers = function(profileId) {
    initListFollowers(profileId).then(function () {
      $scope.listFollowers.show();
    });

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    var success = function(response){
      if (Constants.DEBUGMODE){
        console.log("listFollowers success: ", response);
      }
      $scope.followers = response;
      $ionicLoading.hide();
    }
    Profile.followers({id:profileId}).$promise.then(success);
  };

  $scope.closeListFollowers = function() {
    $scope.listFollowers.hide();
  };

  var initListFollowers = function () {
    if ($scope.listFollowers) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('list-followers.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(listFollowers) {
        $scope.listFollowers = listFollowers;
      });
      $scope.$on('$destroy', function() {
        $scope.listFollowers.remove();
      });
        // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
        $scope.followers = null;
      });
        // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
    }
  };

  $scope.openListFollowings = function(profileId) {
    initListFollowings(profileId).then(function () {
      $scope.listFollowings.show();
    });

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    var success = function(response){
      if (Constants.DEBUGMODE){
        console.log("listFollowings success: ", response);
      }
      $scope.followings = response;
      $ionicLoading.hide();
    }
    Profile.followings({id:profileId}).$promise.then(success);
  };

  $scope.closeListFollowings = function() {
    $scope.listFollowings.hide();
  };

  var initListFollowings = function () {
    if ($scope.listFollowings) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('list-followings.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(listFollowings) {
        $scope.listFollowings = listFollowings;
      });
      $scope.$on('$destroy', function() {
        $scope.listFollowings.remove();
      });
        // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
        $scope.followings = null;
      });
        // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
    }
  };

  $scope.newComment = function(commentModel) {
    console.log("$rootScope.post in PostCommentCtrl:", $scope.post);
    commentModel.post_id = $scope.post.id;
    var comment = new Comment({postId:$scope.post.id, comment:commentModel});
    comment.$save().then(function(c) {
      console.log("$scope.$parent.$parent.$parent.posts:", $scope);
      $scope.comments.push(c);
      commentModel.messages = "";
      $scope.post = c.post;
    });
  };

  $scope.openPostComment = function(post, showKeyboard) {
    $scope.post = post;
    $scope.comments = Comments.query({postId:post.id});
    console.log("openPostComment:", $scope.post);
    if ($window.cordova) $window.cordova.plugins.Keyboard.disableScroll(true);
    $ionicModal.fromTemplateUrl('post-comment.html', {
          // Use our scope for the scope of the modal to keep it simple
          scope: $scope,
          // The animation we want to use for the modal entrance
          //animation: 'slide-in-up',
          animation: 'none',
          focusFirstInput: showKeyboard,
          hardwareBackButtonClose: true
        }).then(function(modal) {
          $scope.postComment = modal;
          $scope.postComment.show();
          if (showKeyboard && $window.cordova) $window.cordova.plugins.Keyboard.show();
    });
  };

  $scope.closePostComment = function() {
    if ($scope.postDetail && $scope.postDetail.isShown()) $scope.postDetail.remove();
    if ($window.cordova) window.cordova.plugins.Keyboard.close();
    $scope.postComment.remove();
  };
    //Cleanup the modal when we're done with it!

  $scope.scrollBottom = function (delegate){
    //$ionicScrollDelegate.scrollBottom(true);
    $ionicScrollDelegate.$getByHandle(delegate).scrollBottom(true);
    console.log ('post comment scroll bottom');
  };

  var initPC = function (showKeyboard) {
    if ($scope.postComment) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('post-comment.html', {
          // Use our scope for the scope of the modal to keep it simple
          scope: $scope,
          // The animation we want to use for the modal entrance
          //animation: 'slide-in-up',
          animation: 'none',
          focusFirstInput: showKeyboard,
          hardwareBackButtonClose: true
        }).then(function(modal) {
          $scope.postComment = modal;
        });
            //Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
          $scope.postComment.remove();
        });
        // Execute action on hide modal
        $scope.$on('postComment.hidden', function() {
          // Execute action
          $scope.closePostComment();
        });
        // Execute action on remove modal
        $scope.$on('postComment.removed', function() {
          // Execute action
          $scope.closePostComment();
        });

        $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
          $scope.postComment.remove();
        });
    }
  }

  $scope.showGoBackButton = function () {
    if ($ionicHistory.backTitle() != null) {
      console.log('hide go back button ' + $ionicHistory.currentStateName() + '| previous view: ' + $ionicHistory.backTitle());
      return false;
    } else {
      console.log('show go back button ' + $ionicHistory.currentStateName() + '| previous view: ' + $ionicHistory.backTitle());
      return true;
    }
  }

  $scope.goBackButton = function ()  {
    $ionicHistory.goBack();
  }

  function showToast1(msg) {
    var toastMessage = $mdToast.simple().content(msg).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(5000);
    $mdToast.show(toastMessage).then(function(response) {
      //alert(response);
      if (response == 'ok') {
        $mdToast.hide();
      }
    });
  }

  function reportUserAbuse(profileId, msg) {

    var profile = new Profile({id:profileId});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    profile.$abuse().then(function(p) {
      console.log("user reported:", p);
      $ionicLoading.hide();
      showToast1(msg);
    });
  };

  function blockUser(profileId) {
    var profile = new Profile({id:profileId});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    profile.$block().then(function(p) {
      console.log("user reported:", p);
      $scope.profile = p;
      $ionicLoading.hide();
      showToast(($scope.isBlocked() ? $tran('USER-BLOCKED-MSG') : $tran('USER-UNBLOCKED-MSG')));
    });
  };

  $scope.isBlocked = function() {
    return $scope.profile.is_blocked;
  }
  $scope.profileMoreShow = function(profileId) {

  // Show the action sheet
    var hideSheet = $ionicActionSheet.show({

      buttons: [
        { text: '<span class=assertive>' + $tran('REPORT-THE-USER-BTN') + '</span>' },
        { text: '<span class=assertive>' + ($scope.isBlocked() ? $tran('UNBLOCK-THE-USER-BTN') : $tran('BLOCK-THE-USER-BTN')) + '</span>' }
      ],
      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
          // add cancel code..
      },
      buttonClicked: function(index) {
        hideSheet();
        console.log(index);
        var lblTemplate = '';
        var lblTitle = "";
        var lblActionButton = $tran('DISMISS-BUTTON');
        var toastMsg = "";

        if (index==0) {
          lblTemplate = '<p style="padding:10px; text-align: center;">' + $tran('ARE-YOU-SURE') + '</p>';
          lblTitle = $tran('REPORT-THE-USER-BTN');
        } else {
          lblTemplate = '<p style="padding:10px; text-align: center;">' + $tran('ARE-YOU-SURE') + '</p>';
          lblTitle = ($scope.isBlocked() ? $tran('UNBLOCK-THE-USER-BTN') : $tran('BLOCK-THE-USER-BTN'));
        }

        var confirmPopup = $ionicPopup.confirm({
            template: lblTemplate,
            title: lblTitle,
            cssClass: 'blockuser',
            buttons: [{text:$tran('CANCEL-BTN')}, {text:'<b>' + $tran('YES-IM-SURE') + '</b>', type:'button-calm',
                        onTap: function(e) {
                          if (index==0) reportUserAbuse(profileId, $tran('USER-REPORTED-MSG'));
                          if (index==1) blockUser(profileId);
                        }

                      }]
        });

        confirmPopup.then(function(res) {
          console.log('Tapped!', res);
        });
        /*
        confirmPopup.then(function(res) {
          console.log(res);
          alert(res);
          if (res) {
            if (index==0) reportUserAbuse(profileId, "User reported");
            if (index==1) blockUser(profileId);
          }
        });
        */

      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() {
      hideSheet();
    }, 5000);
  };

  function showToast(msg) {
    var el = angular.element(document.getElementById('post-comment-modal'));
    var toastMessage = $mdToast.simple().content(msg).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(3000).parent(el);
    $mdToast.show(toastMessage);
  }

  function reportCommentAbuse(commentId, msg) {
    var comment = new Comment({id:commentId});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    comment.$abuse().then(function(p) {
      console.log(msg, p);
      $ionicLoading.hide();
      showToast(msg)
    });
  };

  function removeComment(comment, msg) {
    var comment = new Comment({id:comment.id});
    $ionicLoading.show({
      template: $tran('LOADING')
    });
    comment.$delete().then(function(p) {
      console.log(msg, p);
      console.log($scope.post.comments);
      for (var i in $scope.comments) {
        console.log("i: ", i, ", comment.id: ", comment.id)
        if ($scope.comments[i].id == comment.id) {
          console.log("COMMENT FOUND IN COMMENTS LIST!!!!");
          $scope.comments.splice(i, 1);
          break; //Stop this loop, we found it!
        }
      };
      for (var i in $scope.post.comments) {
        console.log("i: ", i, ", comment.id: ", comment.id)
        if ($scope.post.comments[i].id == comment.id) {
          console.log("COMMENT FOUND IN POST COMMENT!!!!");
          $scope.post.comments.splice(i, 1);
          break; //Stop this loop, we found it!
        }
      };
      $ionicLoading.hide();
      showToast(msg);
    });
  };

  $scope.reportCommentShow = function(comment) {

    // Show the action sheet
    if ($scope.post.is_admin)
      if (comment.user_id == $scope.post.poster.id)
        var buttons = [
          { text: '<span class=assertive>' + $tran('DELETE-BTN') + '</span>' }
        ];
      else
        var buttons = [
          { text: '<span class=assertive>' + $tran('DELETE-AND-REPORT-BTN') + '</span>' }
        ];
    else
      var buttons = [
        { text: '<span class=assertive>' + $tran('REPORT-ABUSE-BTN') + '</span>' }
      ];

    var hideSheet = $ionicActionSheet.show({

      buttons: buttons,
      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
          // add cancel code..
      },
      buttonClicked: function(index) {
        $ionicListDelegate.closeOptionButtons();
        hideSheet();
        console.log(index);
        var lblTemplate = '';
        var lblTitle = "";
        var lblActionButton = "Dismiss";

        if ($scope.post.is_admin)
          if (comment.user_id == $scope.post.user_id)
            removeComment(comment, $tran('COMMENT-DELETED-MSG'));
          else
            removeComment(comment, $tran('COMMENT-REPORTED-AND-DELETED-MSG'));
        else
          reportCommentAbuse(comment.id, $tran('REPORTED-MSG'));

      }
    });
  }

})

.controller('HostRequestCtrl', function($scope, $rootScope, $ionicActionSheet, $timeout, $ionicLoading, $mdToast, $filter, Profile, Constants) {

  var $tran = $filter('translate');

  if ($rootScope.myProfile) {
    $scope.profile = $rootScope.myProfile;
  } else {
    Profile.get({id:'current'}).$promise.then(function(p) {
      $scope.profile = p;
      $rootScope.myProfile = p;
      console.log($scope.profile);
    });
  }

  $scope.baseUrl = Constants.IMG.baseUrl;
  $scope.uploadHostRequestPic = function(requestNum) {

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: '<span class=calm>' + $tran('TAKE-PHOTO-BTN') + '</span>' },
        { text: '<span class=calm>' + $tran('CHOOSE-FROM-GALLERY-BTN') + '</span>' }
      ],

      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        $scope.hostRequestNum = requestNum;
        if (index==0) {
          $scope.takePhoto($scope.uploadHostRequest)
        } else if (index==1) {
          $scope.choosePhoto($scope.uploadHostRequest);
        }
        return true;
      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() {
      hideSheet();
    }, 5000);
  };

  $scope.uploadHostRequest = function(postModel, ionicModal) {

    console.log('$scope.uploadHostRequest called');
    console.log('$scope.uploadHostRequest postModel: ', postModel);
    console.log('$scope.uploadHostRequest hostRequestNum: ', $scope.hostRequestNum);

    if ($scope.hostRequestNum == 1) {
      var profile = new Profile({id:$scope.profile.id, profile:{host_request_1_context: postModel.caption, host_request_1_image: postModel.canvas}});
    } else if ($scope.hostRequestNum == 2) {
      var profile = new Profile({id:$scope.profile.id, profile:{host_request_2_context: postModel.caption, host_request_2_image: postModel.canvas}});
    } else if ($scope.hostRequestNum == 3) {
      var profile = new Profile({id:$scope.profile.id, profile:{host_request_3_context: postModel.caption, host_request_3_image: postModel.canvas}});
    }

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    profile.$save().then(function(p) {
      var toastMessage = $mdToast.simple().content($tran('HOST-REQUEST-SUBMITTED-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(8000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          $mdToast.hide();
        }
      });
      console.log("profile.save resp:", p);
      $ionicLoading.hide();
      ionicModal.remove();
      $scope.profile = p;
      $rootScope.myProfile = p;
    });
  };
})

.controller('VerificationCtrl', function($scope, $rootScope, VerifiedTopic, Profile, $ionicActionSheet, $ionicLoading, $timeout, $mdToast, $filter) {

  var $tran = $filter('translate');

  $scope.iframeHeight = window.innerWidth;
  $scope.verifiedTopics = VerifiedTopic.all();

  if ($rootScope.myProfile) {
    $scope.profile = $rootScope.myProfile;
  } else {
    Profile.get({id:'current'}).$promise.then(function(p) {
      $scope.profile = p;
      $rootScope.myProfile = p;
      console.log($scope.profile);
    });
  }

  $scope.verificationRequest = function(verificationId) {

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: '<span class=calm>' + $tran('TAKE-PHOTO-BTN') + '</span>' },
        { text: '<span class=calm>' + $tran('CHOOSE-FROM-GALLERY-BTN') + '</span>' }
      ],

      cancelText: '<span class=calm>' + $tran('CANCEL-BTN') + '</span>',
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        $scope.verificationId = verificationId;
        if (index==0) {
          $scope.takePhotoOnly($scope.uploadVerification);
          hideSheet();
        } else if (index==1) {
          $scope.choosePhotoOnly($scope.uploadVerification);
          hideSheet();
        }
        return true;
      }
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function() {
      hideSheet();
    }, 5000);
  };

  $scope.uploadVerification = function(canvas) {

    console.log('$scope.uploadVerification called');
    console.log('$scope.uploadVerification canvas: ', canvas);
    console.log('$scope.uploadVerification verificationId: ', $scope.verificationId);

    var params = {id:$scope.profile.id};
    params["verify_image_"+$scope.verificationId] = canvas;
    console.log("params:", params);
    var profile = new Profile(params);

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    profile.$save().then(function(p) {
      console.log("profile.save resp:", p);
      $ionicLoading.hide();
      $scope.profile = p;
      $rootScope.myProfile = p;
      var toastMessage = $mdToast.simple().content($tran('VERIFICATION-SUBMITTED-MSG')).action($tran('OK-BTN')).highlightAction(true).position('top').hideDelay(8000);
      $mdToast.show(toastMessage).then(function(response) {
        if (response == 'ok') {
          $mdToast.hide();
        }
      });
    });
  };
})

.controller('ActivityCtrl', function($scope, $rootScope, $ionicLoading, $filter, Activities, Profile, Constants) {

  var $tran = $filter('translate');

  $scope.thumbnailHeight = 50;

  $ionicLoading.show({
    template: $tran('LOADING')
  });

  var success = function(response){
    if (Constants.DEBUGMODE){
      console.log("activitiesFollowing success: ", response);
    }
    $scope.activitiesFollowing = response;
    $scope.getMyActivities();
  }

  Activities.following().$promise.then(success);
  $scope.getMyActivities = function() {
    var success = function(response){
      if (Constants.DEBUGMODE){
        console.log("activitiesMe success: ", response);
      }
      $scope.activitiesMe = response;
      $ionicLoading.hide();
    }
    Activities.me().$promise.then(success);
  }

  Profile.updateActivitiesTimestamp().$promise.then(function() {
    console.log('111111', $scope);
    $rootScope.badgeActivities = null;
  });

  $scope.parentFolder = function(e) { $rootScope.parentFolder = e; }
  //alert($scope.activities);
})

.controller('DiscoverCtrl', function($scope, $rootScope, News, Profile, Constants) {
  $scope.thumbnailHeight = 50;
  $scope.newss = News.query();
  $scope.baseUrl = Constants.IMG.baseUrl;

  Profile.updateDiscoverTimestamp().$promise.then(function() {
    $rootScope.badgeDiscover = null;
  });
  //alert($scope.activities);
})

.controller("ProfileEditCtrl", function($scope, $rootScope, $state, $ionicLoading, $ionicPopup, $ionicHistory, $timeout, $localstorage, $filter, $translate, Profile, Country, Constants) {

  var $tran = $filter('translate');

  if ($rootScope.myProfile) {
    $scope.profile = $rootScope.myProfile;
    $scope.password_profile = {current_password: "", password: "", password_confirmation: "", is_using_temporary_password: $scope.profile.is_using_temporary_password};
  } else {
    Profile.get({id:'current'}).$promise.then(function(p) {
      $scope.profile = p;
      $rootScope.myProfile = p;
      $scope.password_profile = {password: "", password_confirmation: "", is_using_temporary_password: $scope.profile.is_using_temporary_password};
    });
  }

  $scope.country = Country.all();

  $scope.capitalize = function (s) {
    return s[0].toUpperCase() + s.slice(1);
  }

  $scope.updateProfile = function(profileModel) {
    console.log("profileModel: ", profileModel);
    delete profileModel.avatar;
    var profile = new Profile({id:profileModel.id, profile:profileModel});
    $ionicLoading.show({
      template: $tran('LOADING')
    });

    $localstorage.set('language', profileModel.language);
    console.log(profileModel.language);

    if ($translate.use() != profileModel.language) {
      $translate.use(profileModel.language);
      $ionicHistory.clearCache();
    }

    profile.$save().then(function(p) {
      console.log("profile.save resp:", p);
      $scope.profile = p;
      $rootScope.myProfile = p;
      $ionicLoading.hide();
      $state.go('tab.setting');
    });
  };

  $scope.changePassword = function(profileModel) {

    console.log("profileModel: ", profileModel);

    var profile = new Profile({id:$scope.profile.id, user:profileModel});

    $ionicLoading.show({
      template: $tran('LOADING')
    });

    var success = function(response){
      console.log("profile.changePassword resp:", response);
      $scope.profile = response;
      $rootScope.myProfile = response;
      $ionicLoading.hide();

      var successPopup = $ionicPopup.show({
        template: '<p style="padding:10px; text-align: center;">' + $tran('PASSWORD-CHANGED-MSG') + '</p>',
        title: $tran('SUCCESS'),
        buttons: [
            { text: $tran('OK-BTN') }
        ]
      })

      $timeout(function() {
        successPopup.close(); //close the popup after 3 seconds for some reason
        $state.go('tab.setting');
      }, 3000);
    }

    var error = function(error){
      $ionicLoading.hide();
      if(Constants.DEBUGMODE){
        console.log("profile.changePassword error:", error);
      }
      error_message = "";
      for (var e in error.data.errors) {
        error_message += error.data.errors[e][0] + "<br/>";
      }
      var errorPopup = $ionicPopup.alert({
        template: '<p style="padding:10px; text-align: center;">' + $scope.capitalize(error_message) + '</p>',
        title: $tran('ERROR'),
        scope: $scope,
        buttons: [
            { text: $tran('OK-BTN') }
        ]
      });
    }

    profile.$changePassword().then(success, error);
  };
})

.controller('TabsCtrl', function($window, $ionicPlatform, $scope, $rootScope, $state, $ionicModal, $q, $cordovaCamera, $cordovaNetwork, $jrCrop, $ionicPopup, $ionicLoading, $ionicHistory, $cordovaSocialSharing, $filter, $localstorage, $translate, Profile, Follow, AuthService, Constants, Comments) {

  var $tran = $filter('translate');

  // added to use the detected language to override localstorage
  var language = $localstorage.get('language', $translate.use());

  if ($translate.use() != language) {
    $localstorage.set('language', language);
    $translate.use(language);
  }

  AuthService.ping('TabsCtrl').then(function(resp) {
    if(Constants.DEBUGMODE) {
      console.log('AuthService.ping response: ', resp);
    }
    $rootScope.myProfile = resp;
    $rootScope.badgeActivities = resp.badge_activities > 0 ? resp.badge_activities : null;
    $rootScope.badgeDiscover = resp.badge_discover > 0 ? resp.badge_discover : null;
  }, function(error) {
    console.log('TabsCtrl error: ', error);
  });

  $scope.baseUrl = Constants.IMG.baseUrl;
  $scope.openUploadImage = function(topicId, useCamera) {

    initUI().then(function () {
      $scope.uploadImage.show();
      //$scope.uploadImage.isShown().then($scope.takePhoto());
    });
  };

  $rootScope.$on('posts:updated', function() {
    $rootScope.top100PostsLoaded = false;
    $rootScope.latestPostsLoaded = false;
    $rootScope.friendPostsLoaded = false;
    $rootScope.randomPostsLoaded = false;
  });

  $rootScope.$on('loading:show', function() {
    $ionicLoading.show({
      template: $tran('LOADING')
    });
  });

  $rootScope.$on('loading:hide', function() {
    $ionicLoading.hide();
  });


  // document.addEventListener("deviceready", function () {

  //   // listen for Online event
  //   $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
  //     var onlineState = networkState;
  //   })

  //   // listen for Offline event
  //   $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
  //     var errorPopup = $ionicPopup.alert({
  //       template: '<p style="padding:10px; text-align: center;">No network connection</p>',
  //       title: 'Error',
  //       scope: $scope,
  //       buttons: [
  //           { text: 'Ok' }
  //       ]
  //     });
  //   })

  // }, false);

  $scope.closeUploadImage = function() {
    if ($scope.uploadImage) $scope.uploadImage.hide();
  };
    //Cleanup the modal when we're done with it!

  var initUI = function () {
    if ($scope.uploadImage) {
      return $q.when();
    } else {
      //return $ionicModal.fromTemplateUrl('upload-image.html', {
      return $ionicModal.fromTemplateUrl('photo-camera.html', {
          // Use our scope for the scope of the modal to keep it simple
          scope: $scope,
          // The animation we want to use for the modal entrance
          //animation: 'slide-in-up',
          hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.uploadImage = modal;
          //$scope.takePhoto();
      });
            //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.uploadImage.remove();
      });
        // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
        $scope.closeUploadImage();
      });
        // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
        $scope.closeUploadImage();
      });

      $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
        $scope.uploadImage.remove();
      });

      $scope.$on('modal.isShown', function() {
        //alert('show');
      });

    }
  }
    $scope.signOut = function() {
      Profile.signOut().$promise.then(function () {
        if ($scope.user) $scope.user = null;
        if ($scope.profile) $scope.profile = null;
        if ($rootScope.myProfile) $rootScope.myProfile = null;
        $state.go('account');
      });
    };

    $scope.openTermPolicy = function() {

      initTP().then(function () {
        $scope.termPolicy.show();
      });

    };

    $scope.closeTermPolicy = function() {
      $scope.termPolicy.hide();
    };
    //Cleanup the modal when we're done with it!


    var initTP = function () {
      if ($scope.termPolicy) {
        return $q.when();
      } else {
        return $ionicModal.fromTemplateUrl('term-policy.html', {
          // Use our scope for the scope of the modal to keep it simple
          scope: $scope,
          // The animation we want to use for the modal entrance
          animation: 'slide-in-up',
          hardwareBackButtonClose: true
        }).then(function(modal) {
          $scope.termPolicy = modal;
        });
      }
    }

  $scope.openPrivacyPolicy = function() {
    $ionicModal.fromTemplateUrl('privacy-policy.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.privacyPolicyOptions = modal;
        $scope.privacyPolicyOptions.show();
      });
  };

  $scope.closePrivacyPolicy = function() {
    $scope.privacyPolicyOptions.remove();
  };
  //Cleanup the modal when we're done with it!

  var initTP = function () {
    if ($scope.termPolicy) {
      return $q.when();
    } else {
      return $ionicModal.fromTemplateUrl('term-policy.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.termPolicy = modal;
      });
    }
  };


  $scope.openIntellectualProperty = function() {
    $ionicModal.fromTemplateUrl('intellectual-property.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.intellectualProperty = modal;
        $scope.intellectualProperty.show();
      });
  };

  $scope.closeIntellectualProperty = function() {
    $scope.intellectualProperty.remove();
  };


  $scope.openCommunityGuidelines = function() {
    $ionicModal.fromTemplateUrl('community-guidelines.html', {
        // Use our scope for the scope of the modal to keep it simple
        scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up',
        hardwareBackButtonClose: true
      }).then(function(modal) {
        $scope.communityGuidelines = modal;
        $scope.communityGuidelines.show();
      });
  };

  $scope.closeCommunityGuidelines = function() {
    $scope.communityGuidelines.remove();
  };

  $scope.openImageModal = function() {
    $ionicModal.fromTemplateUrl('image-modal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.imageModal = modal;
      $scope.imageModal.show();
    });

  };

  $scope.closeImageModal = function() {
    $scope.imageModal.remove();
  };

  $scope.imageSrc = 'http://ionicframework.com/img/ionic-logo-blog.png';

  $scope.showImage = function(src) {
    $scope.imageSrc = src;
    $scope.openImageModal();
  }

  $scope.shareAnywhere = function() {
    var message = $tran('INVITE-TO-COOMUS-1') + "\n" + $tran('INVITE-TO-COOMUS-2') + "\n" + $tran('INVITE-TO-COOMUS-3') + "\n" + $tran('INVITE-TO-COOMUS-4');
    $cordovaSocialSharing.share(message, $tran('INVITATION-TO-COOMUS'), $scope.baseUrl + "/images/coomus.png", "http://www.coomus.com");
  }


  $rootScope.$on('$ionicView.beforeEnter', function() {
    $rootScope.hideTabs = true;

    if ($state.current.name === 'tab.topics' || $state.current.name === 'tab.activity'  || $state.current.name === 'tab.search'  || $state.current.name === 'tab.discover'  || $state.current.name === 'tab.profile') {
      //alert($state.current.name);
      $rootScope.hideTabs = false;
    }

    if ($state.current.name === 'tab.topics') {
      //$ionicHistory.
    }
  });

  if (window.cordova) {
    var cameraOption = {
      quality: 80,
      destinationType: ionic.Platform.isIOS() ? Camera.DestinationType.DATA_URL : Camera.DestinationType.DATA_URL,
      sourceType: Camera.PictureSourceType.CAMERA,
      //allowEdit: ionic.Platform.isIOS() ? false : true,
      encodingType: Camera.EncodingType.JPEG,
      correctOrientation: true,
      targetWidth: 1000,
      targetHeight: 1000,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false
    };

    var libraryOption = {
      quality: 80,
      destinationType: ionic.Platform.isIOS() ? Camera.DestinationType.DATA_URL : Camera.DestinationType.DATA_URL,
      sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      allowEdit: ionic.Platform.isIOS() ? false : true,
      // encodingType: Camera.EncodingType.PNG,
      encodingType: Camera.EncodingType.JPEG,
      correctOrientation: true,
      targetWidth: 1000,
      targetHeight: 1000,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false
    };
  }

  $scope.takePhoto = function (callback) {
    //if (ionic.Platform.isAndroid()) $cordovaCamera.cleanup();
    //$cordovaCamera.cleanup();
    if (window.cordova) {
      $cordovaCamera.getPicture(cameraOption).then(function (imageData) {
        //$scope.uploadImage.isShown().then($scope.takePhoto());
        //$scope.openUploadImage();
        $scope.imgURI = "data:image/jpeg;base64," + imageData;
        //$scope.imgURI = imgURI;
        $scope.cropWithCaption($scope.imgURI, callback);
      }, function (err) {
        //alert('close');
          $scope.closeUploadImage();
          // An error occured. Show a message to the user
      })
    } else {
      $scope.cropWithCaption('http://img.snapsoap.com/images/all-char.png', callback);
    }
  }

  $scope.choosePhoto = function (callback) {
    if (window.cordova) {
      $cordovaCamera.getPicture(libraryOption).then(function (imageData) {
        $scope.imgURI = "data:image/jpeg;base64," + imageData;
        //$scope.imgURI = imgURI;
        $scope.cropWithCaption($scope.imgURI, callback);
      }, function (err) {
        // An error occured. Show a message to the user
        $scope.closeUploadImage();
      })
    } else {
      $scope.cropWithCaption('http://img.snapsoap.com/images/all-char.png', callback);
    }
  }

  $scope.takePhotoOnly = function (callback) {
    //if (ionic.Platform.isAndroid()) $cordovaCamera.cleanup();
    console.log("calling takePhotoOnly()");
    if (window.cordova) {
      $cordovaCamera.getPicture(cameraOption).then(function (imageData) {
        //$scope.uploadImage.isShown().then($scope.takePhoto());
        //$scope.openUploadImage();
        $scope.imgURI = "data:image/jpeg;base64," + imageData;
        //$scope.imgURI = imgURI;
        $scope.cropOnly($scope.imgURI, callback);
      }, function (err) {
        //alert('close');
        $scope.closeUploadImage();
        // An error occured. Show a message to the user
      })
    } else {
      $scope.cropOnly('http://img.snapsoap.com/images/all-char.png', callback);
    }
  }

  $scope.choosePhotoOnly = function (callback) {
    console.log("calling choosePhotoOnly()");
    if (window.cordova) {
      $cordovaCamera.getPicture(libraryOption).then(function (imageData) {
        $scope.imgURI = "data:image/jpeg;base64," + imageData;
        //$scope.imgURI = imgURI;
        $scope.cropOnly($scope.imgURI, callback);
      }, function (err) {
        // An error occured. Show a message to the user
        $scope.closeUploadImage();
      })
    } else {
      $scope.cropOnly('http://img.snapsoap.com/images/all-char.png', callback);
    }

  }

  $scope.testcrop = function() {
    $scope.cropWithCaption('http://dreamatico.com/data_images/car/car-1.jpg');
  }

  $scope.iframeHeight = $window.innerWidth;
  var screenWidth = $window.innerWidth;

  $scope.cropWithCaption = function(image, callback) {
    $jrCrop.crop({
            url: image,
            cancelText: $tran('CANCEL-BTN'),
            chooseText: $tran('CHOOSE-BTN'),
            width: screenWidth,
            height: screenWidth
    }).then(function(canvas) {
      console.log('canvas: ', canvas);
      // success! and upload to server
      //$scope.cropImage = canvas.toDataURL("image/png").replace(/^data:image\/[^;]/, 'data:application/octet-stream');
      $ionicModal.fromTemplateUrl('result-cropped.html', {
          scope: $scope,
          animation: 'none'
        }).then(function(modal) {
          $scope.modal = modal;
          $scope.post = {caption: "", canvas: null};
          $scope.uploading = false;
          $scope.callback = callback;
          $scope.modal.show();
          //alert('just show');
          //document.querySelector('.cropped-canvas').appendChild(canvas);
          var image = new Image();
          image.id = "pic";
          image.src = canvas.toDataURL();
          document.getElementById('image_for_crop').appendChild(image);
          $scope.post.canvas = canvas.toDataURL("image/png").replace(/^data:image\/[^;]/, 'data:application/octet-stream');
        });
    }, function() {
      //alert('cancel');
    // User canceled or couldn't load image.
    });
  };

  $scope.cropOnly = function(image, callback) {
    $jrCrop.crop({
            url: image,
            cancelText: $tran('CANCEL-BTN'),
            chooseText: $tran('CHOOSE-BTN'),
            width: screenWidth,
            height: screenWidth
    }).then(function(canvas) {
      // success! and upload to server
      console.log("cropOnly called");
      callback(canvas.toDataURL("image/png").replace(/^data:image\/[^;]/, 'data:application/octet-stream'));
    }, function() {
      //alert('cancel');
    // User canceled or couldn't load image.
    });
  };
})

.controller('TermPolicyCtrl', function($scope) {
})

.controller('SearchCtrl', function($scope, $rootScope, $timeout, $ionicLoading, $filter, Profiles, Constants) {

  var $tran = $filter('translate');
  $scope.parentFolder = function(e) { $rootScope.parentFolder = e; }

  $scope.isDefault = true;
  $scope.searchCompleted = false;
  $scope.baseUrl = Constants.IMG.baseUrl;

  var success = function(response){
    if (Constants.DEBUGMODE){
      console.log("searchProfiles success: ", response);
    }
    $scope.profiles = response;
    $scope.searchCompleted = true;
    $ionicLoading.hide();
  }

  $ionicLoading.show({
    template: $tran('LOADING')
  });

  Profiles.defaults().$promise.then(success);

  $scope.searchProfiles = function() {
    $ionicLoading.show({
      template: $tran('LOADING')
    });

    $scope.searchCompleted = false;

    //aa = $ionicFilterBarConfigProvider.placeholder({search:"Search for an user"});
    console.log('searchText: ', $scope.searchText);
    if ($scope.searchText && $scope.searchText != "") {
      Profiles.query({text:$scope.searchText}).$promise.then(success);
      $scope.isDefault = false;
    } else {
      Profiles.defaults().$promise.then(success);
      $scope.isDefault = true;
    }
  };

  $scope.focus = function() {
    return {
      link: function (scope, element) {
        console.log(element);
        element[0].focus();
      }
    }
  }

  $scope.resetSearchText = function (o) {
    //document.querySelector('.searchText').text = '';
    ob = document.getElementById('searchText')
    console.log(ob);
    $scope.focus();

    //ob.focus();
    //document.element('.searchText').focus();
  }

  $scope.$on('$ionicView.enter', function() {
    $scope.searchProfiles($scope.searchText);
  });

});